package com.yaohun.gameranking.data;

import org.bukkit.configuration.ConfigurationSection;
import org.bukkit.configuration.file.FileConfiguration;

import java.util.HashMap;

public class UserData {

    private String userName;

    private HashMap<String ,Integer> pointsMap;

    public UserData(ConfigurationSection section,String userName){
        this.userName = userName;
        HashMap<String ,Integer> hashMap = new HashMap<>();
        for (String key : section.getKeys(false)){
            hashMap.put(key,section.getInt(key));
        }
        this.pointsMap = hashMap;
    }
    public UserData(String userName){
        this.userName = userName;
        this.pointsMap = new HashMap<>();
    }

    public String getUserName() {
        return userName;
    }

    public int getPoints(String key){
        if(this.pointsMap.get(key) == null){
            return 0;
        }
        return this.pointsMap.get(key);
    }

    public void setPoints(String key,int amount) {
        this.pointsMap.put(key,amount);
    }
    public void addPoints(String key,int amount) {
        int nowAmount = getPoints(key) + amount;
        if(nowAmount >= 2000000000){
            nowAmount = 2000000000;
        }
        setPoints(key,nowAmount + amount);
    }
    public void takePoints(String key,int amount) {
        int nowAmount = getPoints(key) - amount;
        if(nowAmount <= 0){
            nowAmount = 0;
        }
        setPoints(key,nowAmount);
    }

    public HashMap<String, Integer> getPointsMap() {
        return pointsMap;
    }

    public void setPointsMap(HashMap<String, Integer> pointsMap) {
        this.pointsMap = pointsMap;
    }
}
