package com.yaohun.gameranking.manager;

import com.yaohun.gameranking.GameRanking;
import com.yaohun.gameranking.data.UserData;
import com.yaohun.gameranking.data.UserJson;
import org.bukkit.block.data.type.Farmland;
import org.bukkit.configuration.ConfigurationSection;
import org.bukkit.configuration.file.FileConfiguration;

import java.text.SimpleDateFormat;
import java.util.*;

public class RankManager {
    private HashMap<String, List<UserData>> timeUserMap = new HashMap<>();
    public RankManager(FileConfiguration yml){
        for (String time : yml.getKeys(false)){
            List<UserData> userDataList = new ArrayList<>();
            ConfigurationSection section = yml.getConfigurationSection(time);
            if(section == null) {continue;}
            for (String userName : section.getKeys(false)) {
                ConfigurationSection section1 = section.getConfigurationSection(userName);
                if(section1 == null) {continue;}
                userDataList.add(new UserData(section1,userName));
            }
            timeUserMap.put(time,userDataList);
        }
    }

    public void SaveRankingData(FileConfiguration yml){
        String timeKey = getTime("yyyy-MM-dd");
        List<UserData> userDataList = getUserDataList(timeKey);
        for (UserData userData : userDataList) {
            HashMap<String, Integer> hashMap = userData.getPointsMap();
            for (String key : hashMap.keySet()) {
                yml.set(timeKey + "." + userData.getUserName() + "." +key,hashMap.get(key));
            }
        }
        GameRanking.inst().saveConfig();
    }

    public boolean isUserDataExit(String timeKey,String userName){
        List<UserData> userDataList = getUserDataList(timeKey);
        for (UserData userData : userDataList){
            if(userData.getUserName().equalsIgnoreCase(userName)){
                return true;
            }
        }
        return false;
    }
    public UserData getUserData(String timeKey,String userName){
        List<UserData> userDataList = getUserDataList(timeKey);
        for (UserData userData : userDataList){
            if(userData.getUserName().equalsIgnoreCase(userName)){
                return userData;
            }
        }
        return new UserData(userName);
    }

    public List<UserData> getUserDataList(String timeKey){
        if(this.timeUserMap.get(timeKey) == null){
            this.timeUserMap.put(timeKey,new ArrayList<>());
            return this.timeUserMap.get(timeKey);
        }
        return this.timeUserMap.get(timeKey);
    }

    public HashMap<String, List<UserData>> getTimeUserMap() {
        return timeUserMap;
    }

    public String getTime(String format){
        Date date = Calendar.getInstance().getTime();
        SimpleDateFormat datatime = new SimpleDateFormat(format);
        return datatime.format(date);
    }
}
